module Paradoxo

abstract sig Pessoa {
	pai : lone Homem,
	mae : lone Mulher
}

sig Homem extends Pessoa {}

sig Mulher extends Pessoa {}

fact Biologia {
	no p : Pessoa | p in p.^(pai+mae)
}

run {}

fun filho : Pessoa -> Pessoa {
	~(pai+mae)
}

check {no p : Pessoa | p in p.^filho}

fun avo : Pessoa -> Pessoa {
	(pai+mae).(pai+mae)
}

run {some p : Pessoa | p in p.avo} for 6
