module Exps

sig A {
	R : set B
}

sig B {
}

pred Injectiva {
	all x, y : A, z : B | z in x.R && z in y.R => x=y
}

pred Injectiva' {
	all x : B | lone R.x
}

pred Injectiva'' {
	R.~R in iden :> A
}

pred Injectiva''' {
	R in A lone -> B
}

run Injectiva

pred Sobrejectiva {
	R in A some -> B
}

pred Sobrejectiva' {
	all x : B | some R.x
}

pred Sobrejectiva'' {
	B <: iden in ~R.R
}

pred Sobrejectiva''' {
	A.R = B
}

assert MesmaDef {
	Sobrejectiva <=> Sobrejectiva'''
}

check MesmaDef
